/*  How to make : gcc pfm686.c -o pfm686.g32 -O0 -Wall  */
/*  pfm686 ver1.2B DysanKeihin & (koji) at fext */


#include <stdio.h>
#include <dos.h>
#include <stdlib.h>
#include <math.h>


/*
#define PRINT_IMED

#define DEBUG 
*/

#define COUNTER 1193180 /* Hz */

#define cli asm volatile("cli");
#define sti asm volatile("sti");

#define MEM_1M 0xe0000000
#define PHY_1M 0x100000
#define PUSH_CODE          32



#define TickSet RDTSC(TickStart)
#define TickGet RDTSC(TickStop)



static volatile long *pgdir;  /* Page Directry */
static volatile long *pgtbl;  /* Page Table */
static long seg_base;  /* Segment Base Addr (Linear) */
char flag_p5=0;

static unsigned long TickStart, TickStop, Tick;

union REGS inregs,outregs;

double CycleTime;
unsigned long DelayRDTSC;



#define IOtickSet\
  asm volatile\
  ("\
     movb $0x30,%%al\n\
     outb %%al,$0x43\n\
     xorb %%al,%%al\n\
     outb %%al,$0x40\n\
     outb %%al,$0x40\n\
   ":\
    :\
    :"ax"\
  )


#define IOtickGet(counter_l)\
  asm volatile\
  ("\
     movb $0x00,%%al\n\
     outb %%al,$0x43\n\
     inb $0x40,%%al\n\
     xchgb %%al,%%ah\n\
     inb $0x40,%%al\n\
     xchgb %%al,%%ah\n\
     movw %%ax,%0\n\
   ":"=g"(counter_l)\
    :\
    :"ax"\
  )


#define IOtickRecover\
  asm volatile\
  ("\
     movb $0x36,%%al      /*timer0(system)*/\n\
     outb %%al,$0x43\n\
     xorw %%ax,%%ax\n\
     outb %%al,$0x40\n\
     outb %%al,$0x40\n\
   ":\
    :\
    :"ax"\
  )








#define RDTSC(CounterLo)\
  asm volatile\
  ("\
     .byte 0x0f\n\
     .byte 0x31\n\
     movl %%eax,%0\n\
   ":"=g"(CounterLo)\
    :\
    :"ax","dx"\
  )






#define store_string(p,elsize)\
  asm volatile\
  ("\
     .align 4,0x90\n\
     pushl %%eax\n\
     pushl %%ecx\n\
     pushl %%edi\n\
     cld\n\
     movl  %1,%%ecx\n\
     movl  %0,%%eax\n\
     movl  %%eax,%%edi\n\
     movl  $-1,%%eax\n\
     rep\n\
       stosl\n\
     popl %%edi\n\
     popl %%ecx\n\
     popl %%eax\n\
   ":\
    :"g"((p)),"g"(elsize)\
    :"ax","cx","di"\
  )





#define load_string(p,elsize)\
  asm volatile\
  ("\
     .align 4,0x90\n\
     pushl %%eax\n\
     pushl %%ecx\n\
     pushl %%esi\n\
     movl  %0,%%eax
     movl  %%eax,%%esi
     movl  %1,%%ecx\n\
     cld\n\
     rep\n\
       lodsl  \n/*  <-- EAX is affected  */ \n\
     popl %%esi\n\
     popl %%ecx\n\
     popl %%eax\n\
   ":\
    :"g"((p)),"g"((elsize))\
    :"ax","cx","si"\
  )





#define do_continuous_push(p_org, no_of_push, stack_start_point)\
  asm volatile\
  ("\
     movl  %0,%%eax\n\
     movl  %1,%%ecx\n\
     movl  %2,%%edx\n\
     call  %%eax\n\
   ":\
    :"g"(p_org),"g"(no_of_push),"g"(stack_start_point)\
    :"ax","cx","dx"\
  )





void exagoge(char e_level,char *err_mes1,char *err_mes2)
{
  if (*err_mes2 == (char)NULL) fprintf(stderr,"%s \n",err_mes1);
  else fprintf(stderr,"%s [%s]\n",err_mes1,err_mes2);
  exit(e_level);
}




long ExactTick()
{
  if (TickStop > TickStart) Tick = TickStop-TickStart;
  else Tick = TickStop + (unsigned long)(~TickStart) + 1;
  return(Tick);
}



void set_code_continuous_push(long *p_start)
{ long i;
  unsigned char *p;

  p = (char *) p_start;

  *p++ = 0x89;        /*  movl  %esp,%eax */
  *p++ = 0xe0;
  *p++ = 0x89;        /*  movl  %edx,%esp */
  *p++ = 0xd4;

  for (i=0; i<64; i++)
    *p++ = 0x60;  /*  pushal*/

  *p++ = 0xe2;    /* loop  0xbe-0xfe = start add of push (-0x40) */
  *p++ = 0xbe;

  *p++ = 0x89;   /*   movl  %eax,%esp */
  *p++ = 0xc4;

  *p++ = 0xc3; /* ret immediate */

}



void set_code_continuous_push_overhead(long *p_start)
{
  unsigned char *p;

  p = (char *) p_start;

  *p++ = 0x89;        /*  movl  %esp,%eax */
  *p++ = 0xe0;
  *p++ = 0x89;        /*  movl  %edx,%esp */
  *p++ = 0xd4;

  *p++ = 0xe2;    /* loop  0xfe  */
  *p++ = 0xfe;

  *p++ = 0x89;   /*   movl  %eax,%esp */
  *p++ = 0xc4;

  *p++ = 0xc3; /* ret immediate */

}





#define call_test_code(p_org)\
  asm volatile\
  ("\
     movl  %0,%%eax\n\
     call  %%eax\n\
   ":\
    :"g"(p_org)\
    :"ax"\
  )





long fill_test_code(long *start,long elsize)
{ long readblock,i;
  char *p;

  readblock = elsize / (24 / 4);
  p = (char *)start;

  for(i=0; i<readblock; i++)
  {
    *p++ = 0x81;/* 81c300000000   adc eax,0x00000000      */
    *p++ = 0xc3;
    *p++ = 0x00;
    *p++ = 0x00;
    *p++ = 0x00;
    *p++ = 0x00;
    *p++ = 0x81;/* 81c000000000   adc ebx,0x00000000      */
    *p++ = 0xc0;
    *p++ = 0x00;
    *p++ = 0x00;
    *p++ = 0x00;
    *p++ = 0x00;
    *p++ = 0x81;/* 81c100000000   adc ecx,0x00000000      */
    *p++ = 0xc1;
    *p++ = 0x00;
    *p++ = 0x00;
    *p++ = 0x00;
    *p++ = 0x00;
    *p++ = 0x81;/* 81c200000000   adc edx,0x00000000      */
    *p++ = 0xc2;
    *p++ = 0x00;
    *p++ = 0x00;
    *p++ = 0x00;
    *p++ = 0x00;
  }
  *p++ = 0xc3; /* ret immediate */

  return(readblock);
}




int init_pagdir(void) /* Cth (of the Watery Abyss) */
{
  long cr3;
  short ds,ss;
  long base1, base2;

  /* Get Addr of Page Dir */
  asm ("
    .byte 0x0f, 0x20, 0xd8;\n/* mov cr3 into eax */\n
    movl %%eax, %0;
    ": "=g"(cr3) : :"ax"
  );
  pgdir = (long *) (MEM_1M + (cr3 & ~0xfff));

  /* Get Segment Base Addr from GDT */
  asm ("movw %%ds, %%ax; movw %%ax, %0": "=g"(ds): :"ax");
  asm ("movw %%ss, %%ax; movw %%ax, %0": "=g"(ss): :"ax");
#ifdef DEBUG
  printf("ds:%x ss%x\n",ss,ds);
#endif
  if (ds & 0x4 || ds != ss )   return (1);
  
  if (ds & 0x7 ) fprintf(stdout,"ds:%x \n",ds);
  
  asm ("
    push %%es;
    movw %%ds, %%bx; andl $0xfff8, %%ebx;   \n/* Set Offset of DS in GDT */\n
    movw $0x08, %%ax; movw %%ax, %%es;    \n/* Set ES points to GDT */\n
    movl %%es:(%%ebx), %%eax;
    movl %%eax, %0;
    movl %%es:4(%%ebx), %%eax;
    movl %%eax, %1;
    pop %%es;
    ": "=g"(base1), "=g"(base2): : "ax", "bx"
  );
  seg_base = base2 & 0xff000000 | (base2 & 0xff) << 16 | ((unsigned) base1 >> 16);
  return (0);
}




long get_phyadr(void *offset) /* Cth (of the Watery Abyss) */
{
  long pde, pte;
  unsigned long ladr;    /* Linear Address */

  ladr = seg_base + (long) offset;
  pde = pgdir[ladr >> 22];
  if (!(pde & 1))   return (-1);  /* Page Table Not Presented */
  pgtbl = (long *) (MEM_1M + (pde & ~0xfff));

  pte = pgtbl[(ladr >> 12) & 0x3ff];
  if (!(pte & 1))   return (-1);  /* Page Not Presented */
  return ((pte & ~0xfff) + (ladr & 0xfff));
}







#define cpuid(i_eax,r_eax,r_ebx,r_ecx,r_edx)\
  asm volatile\
  ("\
\n/*   pushl %%ebx  */\n
     movl %4,%%eax
     .byte 0x0f
     .byte 0xa2
     movl %%eax,%0
     movl %%ebx,%1
     movl %%ecx,%2
     movl %%edx,%3
\n/*   popl  %%ebx  */\n
   ":"=g"(r_eax),"=g"(r_ebx),"=g"(r_ecx),"=g"(r_edx)\
    :"g"(i_eax)\
    :"ax","bx","cx","dx"\
  )





#define MMXFLAG 0x00800000  /* Bit 23*/

long get_cpuid(char *id_string)
{ volatile unsigned long i_eax,r_eax,r_edx;
  volatile unsigned long string_reg[4];
  char vendor_string[32], p5_bug_string[64],cputype[7],cpu[4];
  long i,j;
  volatile double c;

  asm volatile /* Whether the CPU has ID string */
  ("
     pushfl
     pushfl
     popl  %%eax
     orl  $0x200000,%%eax
     pushl %%eax
     popfl
     pushfl
     popl  %%eax
     popfl
     movl  %%eax,%0
   ":"=g"(r_eax)
    :
    :"ax"
  );

#ifdef DEBUG
fprintf(stderr,"%lx \n",r_eax);
#endif

  if (!(r_eax & 0x200000))  /* if bit21==1 then P5,P6...*/
  { *id_string = (char)NULL;
#ifdef DEBUG
  printf(" It doesen't have CPUID. \n");
#endif
    return(0);
  }

#ifdef DEBUG
  printf(" It has CPUID. \n");
#endif

  vendor_string[0] = (char)NULL;
  i_eax=0;
  cpuid(i_eax,string_reg[3],string_reg[0],string_reg[2],string_reg[1]);
  for(i=0; i<3; i++)
    for(j=0; j<4; j++)
      vendor_string[i*4+j] = (char)( 0xff & (string_reg[i] >> j*8) );
  vendor_string[12] = (char)NULL;

  i_eax=1;
  cpuid(i_eax,r_eax,string_reg[0],string_reg[2],string_reg[1]);

  sprintf(cputype," ??? ");
  if ((r_eax & 0x0ff0) == 0x0000 ) sprintf(cputype,"  non ");
  if ((r_eax & 0x0ff0) == 0x0400 ) sprintf(cputype," 486DX");
  if ((r_eax & 0x0ff0) == 0x0410 ) sprintf(cputype," 486DX");
  if ((r_eax & 0x0ff0) == 0x0420 ) sprintf(cputype," 486SX");
  if ((r_eax & 0x0ff0) == 0x0430 ) sprintf(cputype,"486DX2");
  if ((r_eax & 0x0ff0) == 0x0440 ) sprintf(cputype," 486SL");
  if ((r_eax & 0x0ff0) == 0x0450 ) sprintf(cputype,"486SX2");
  if ((r_eax & 0x0ff0) == 0x0470 ) sprintf(cputype,"WBEDX2");
  if ((r_eax & 0x0ff0) == 0x0480 ) sprintf(cputype,"  DX4 ");
  if ((r_eax & 0x0ff0) == 0x0420 ) sprintf(cputype,"  UMC ");
  if ((r_eax & 0x0ff0) == 0x0510 ) { sprintf(cputype,"  P5  "); flag_p5 = 1; }
  if ((r_eax & 0x0ff0) == 0x0520 ) { sprintf(cputype," P54C "); flag_p5 = 1; }
  if ((r_eax & 0x0ff0) == 0x0530 ) { sprintf(cputype," P24T "); flag_p5 = 1; }
  if ((r_eax & 0x0ff0) == 0x0540 ) sprintf(cputype," P55C ");
  if ((r_eax & 0x0ff0) == 0x0570 ) { sprintf(cputype,"P5note"); flag_p5 = 1; }
  if ((r_eax & 0x0ff0) == 0x04e0 ) sprintf(cputype,"Am5x86");
  if ((r_eax & 0x0ff0) == 0x0610 ) sprintf(cputype,"  P6  ");
  if ((r_eax & 0x0ff0) == 0x0630 ) sprintf(cputype,"Pen-II");
  if ((r_eax & 0x0ff0) == 0x0560 ) sprintf(cputype,"AMD K6");

  sprintf(p5_bug_string,"\0");
  if( flag_p5 )
  { c = 824633702449.0;
    if( fabs (1.0 - (1.0/c)*c) > 0.00000000000001 )
      sprintf(p5_bug_string,"\n| This FPU is BUGGY version.             |");
  }

  i_eax=1;
  cpuid(i_eax,r_eax,string_reg[0],string_reg[2],r_edx);

  if ( MMXFLAG & r_edx) sprintf(cpu,"MMX");
  else sprintf(cpu,"CPU");

  sprintf(id_string,"|%s:%6s[%12s Fam%1ld Mdl%1ld Stp%2ld]|%s\0",cpu,
                    cputype,vendor_string,0x0f&(r_eax>>8),0x0f&(r_eax>>4),0x0f&r_eax,p5_bug_string );

  return(1);
}






#define CMOS_ADDR   0x70
#define CMOS_SEC    0x00
#define CMOS_DATA   0x71


void GetCycleTime(void)
{
  unsigned long Diff;
  unsigned short NewCounter,PreviousCounter;
  int j;
  unsigned char sec,sec1;
  long CounterValSec, Vcount;

  for(j=0; j<2; j++)
  {
    TickSet;
    TickGet;
  }
  if (TickStart == TickStop ) 
    exagoge(1," Sorry, this CPU doesn't have RDTSC instruction.\n Use PFM586 or PFM486.","");

  DelayRDTSC = ExactTick();
  IOtickSet;

  IOtickGet(PreviousCounter);  /* wait for tick*/
  while(1)
  { IOtickGet(NewCounter);
    if ( NewCounter > PreviousCounter) break;
    PreviousCounter = NewCounter;
  }


  for(j=0; j<2; j++)
  {
    TickSet;

    { int i=0;                  /* wait for 10 ticks*/
      while(i<10)
      { IOtickGet(PreviousCounter);
        while(1)
        { IOtickGet(NewCounter);
          if ( NewCounter > PreviousCounter) break;
          PreviousCounter = NewCounter;
        }
        i++;
      }
    }

    TickGet;
  }
  
  Diff = ExactTick()-DelayRDTSC;

/*  CycleTime = 1./COUNTER*(double)(10*0x10000)/(double)Diff;  -- v 1.1*/

#ifdef DEBUG
printf("Delay:%lx\n",DelayRDTSC);
printf("Diff :%lx\n",Diff);
#endif

/* Check CMOS clock */
  
  cli;
  outportb(CMOS_ADDR, CMOS_SEC);
  sec = inportb(CMOS_DATA);

  Vcount = 0;
  while(1)
  { outportb(CMOS_ADDR, CMOS_SEC);
    if ((sec1 = inportb(CMOS_DATA)) == sec) { if ( 10000 == Vcount++) break; }
    else Vcount = 0;
    sec = sec1;
  }
  while(1)
  { outportb(CMOS_ADDR, CMOS_SEC);
    if (sec != inportb(CMOS_DATA))  break;
  }
  

  TickSet;

  Vcount = 0;
  while(1)
  { outportb(CMOS_ADDR, CMOS_SEC);
    if ( (sec1 = inportb(CMOS_DATA))==sec ) { if ( 10000 == Vcount++) break; }
    else Vcount = 0;
    sec = sec1;
  }
  while(1)
  { outportb(CMOS_ADDR, CMOS_SEC);
    if (sec != inportb(CMOS_DATA))  break;
  }
  TickGet;
 
  CounterValSec = ExactTick();
 
  sti;
#ifdef DEBUG
  fprintf(stdout,"%ld\n",CounterValSec);
  fprintf(stdout,"%lf\n",COUNTER/(double)(10*0x10000)*(double)Diff);
#endif
  CycleTime = 1./CounterValSec;
  if (abs ( (double)CounterValSec/1000000. - COUNTER/(double)(10*0x10000)*(double)Diff/1000000) > 0.1 )
  { fprintf(stdout,"-------------------------------------------------\n");
    fprintf(stdout,"Either CMOS-RTC or 14.318MHz clock seems strange.\n");
    fprintf(stdout,"factor : :%5.4f\n",CounterValSec/(COUNTER/(double)(10*0x10000)*(double)Diff));
  }
}








/*============================================================================================================*/




void main(int argc,char **argv)
{ long i,j,k;
  long fillsize,elsize,allocsize,kbytes,readblock_er,readblock_mr;
  long no_of_push,no_of_push_allocsize,*stack_start_point,*stack_start_point_allocsize;
  unsigned long io_delay=0,counter_val_mr,counter_val_er,counter_val_mw,counter_val_ew;
  long *min_p_org,*p_org,*fill,*start,*clearance;
  char vendor_string[128],CacheSizeString[128];
  double time_er,time_ew,time_mr,time_mw,loop_overhead,freq,devide=1.0;
  char v=0;
  long int15mem=0,DiscontinuousCounter;


  start = (long *)0;

  fprintf(stdout,"\n-- pfm686 ver1.2B  DysanKeihin & (koji) --\n");

/* dpmi test */
  inregs.x.ax=0x0400;
  int86(0x31,&inregs,&outregs);
  if (outregs.x.bx & 1 ) exagoge(1,"PFM686 cannot run under DPMI.","");

/* int15 memory test */
  inregs.x.ax=0x8800;
  int86(0x15,&inregs,&outregs);
  if ((long)outregs.x.ax > 1024 ) int15mem = ((long)outregs.x.ax + 1024)*1024;
  if (int15mem > 0xff00*1024 ) int15mem = (0xffff * 2 )*1024; 
  /*if this PC has more than 64M memory, int15mem is fixed at 128M */

#ifdef DEBUG
    printf("Maxmum address of int15mem %lx \n",int15mem);
#endif


  CacheSizeString[0] = '\0';
  kbytes = 256;
  if (argc != 1)
    for (i=1; i<argc; i++)
    { if ( strchr(argv[i],'v') != NULL || strchr(argv[i],'V') != NULL) v=1;
      if ( '0' <= argv[i][0] && argv[i][0] <= '9')
      { kbytes = atol(argv[i]);
        if ( (double)kbytes != atof(argv[i]))
          exagoge(-1,"Sorry, cache size must be integer.",argv[i]);
        if ( kbytes <= 1 ) exagoge(-1,"Cache size must be more than 2kbytes.",argv[i]);
        sprintf(CacheSizeString,"| Cache size : [%4ld]Kbytes              |",kbytes);
      }
      if ( strchr(argv[i],'a') != NULL || strchr(argv[i],'A' ) != NULL)
      { if( int15mem ==0 ) exagoge(-1,"Start address can be defined under INT15mem only.","");
        if( i+1 > argc ) exagoge(-1,"Please define start address.","");
        sscanf(argv[i+1],"%x",&k);
        start = (long*)(MEM_1M + k);
        i++;
      }
      if ( strchr(argv[i],'t') != NULL || strchr(argv[i],'T' ) != NULL)
      {
        if( i+1 > argc ) exagoge(-1,"Please define start address.","");
        sscanf(argv[i+1],"%lf",&devide);

        i++;
      }
    }



#ifdef DEBUG
    if ((long)start != 0)
    {
      if (init_pagdir()) exagoge(-1,"Data Segment Selector Points LDT","");
      *start = 0xffffffff;
      printf("v=%d kbytes=%ld log_start:%p  phy_start:%lx\n",v,kbytes,start,get_phyadr(start));
    }
#endif

  if ( kbytes & 1 == 1 )
  { fprintf(stderr,"Please define cache size with even value.\n");
    kbytes++;
  }



  if ( kbytes > 32 ) kbytes -=2;
  elsize = kbytes*256;/* array size counted in long */

  if ( elsize < 65500 ) allocsize = 65500;
  else allocsize = elsize;


  fillsize = ( elsize*2 > 1024*256 )? elsize*2:1024*256;

  p_org = (long *)malloc((allocsize + PUSH_CODE)*4 + 16);
  min_p_org = p_org;
  if (start != (long *)0)
  {
#ifdef DEBUG
  printf("elsize:%lx  kbytes:%lx  allocsize:%lx  fillsize:%lx \n",elsize,kbytes,allocsize,fillsize);
  printf("start-MEM_1M:%lx > p_org:%lx && start+elsize*4- MEM_1M:%lx < int15mem:%lx\n",(long)start - MEM_1M,(long)p_org+PHY_1M,(long)start + elsize*4 - MEM_1M,int15mem);
#endif
    if ( (long)start - MEM_1M >= (long)min_p_org+PHY_1M
        && (long)start + elsize*4 - MEM_1M < int15mem)
    { free(p_org);
      p_org = start;
    }
    else
    { fprintf(stdout,"Invalid address.[%lx - %lx]\nIt must be within [%lx - %lx].\n",(long)start-MEM_1M,(long)start-MEM_1M+elsize*4,(long)min_p_org+PHY_1M,int15mem);
      exagoge(-1,"","");
    }
  }
  else
  {
    p_org = p_org + 8 - ((long)p_org & 0x1fL)/4 ; /*align 8bytes*/
  }


  for (i=0; i<elsize + PUSH_CODE + 4; i++)
    *(p_org + i) = 0xffffffff;
  no_of_push = elsize/64/8;
  no_of_push_allocsize = allocsize/64/8;
  stack_start_point = p_org + elsize + PUSH_CODE;
  stack_start_point_allocsize = p_org + allocsize + PUSH_CODE;



/* fill  dummy ̊Ԃ fill ̑傫̌Ԃ󂯂 */

  if (start == (long *)0)
  {
    clearance = (long *)malloc(allocsize *4 );
     for (i=0; i<allocsize ; i++)
       *(clearance + i) = 0xffffffff;
  }





  if (start != (long *)0)
  {
#ifdef DEBUG
  printf("int15mem - (long)(p_org + elsize)-MEM_1M:%lx > p_org:%lx\n",int15mem - ((long)(p_org + elsize) - MEM_1M),(long)p_org-MEM_1M - (PHY_1M+(long)min_p_org));
  printf("p_org:%lp  elsize:%lx  p_org+elsize:%lp\n",p_org,elsize,p_org + elsize);
#endif
    if ( int15mem - ((long)(p_org + elsize) - MEM_1M)
         >  (long)p_org-MEM_1M - (PHY_1M+(long)min_p_org))
    { fill = p_org + allocsize*2 + 256;  /* elsize*2 Ƃ̂clearance̕ */
      if ( (long)fill + fillsize*4 + 16 >= int15mem)
        exagoge(-1,"Too small int15 memory","p_org<fill");
#ifdef DEBUG
  printf("Logic1:fill:%lp\n",fill);
#endif
    
    }
    else
    { fill = p_org - fillsize - 16;
      if ( (long)fill - MEM_1M < PHY_1M )
        exagoge(-1,"Too small int15 memory","fill<p_org");
#ifdef DEBUG
  printf("Logic2:fill:%lp\n",fill);
#endif
    }
  }
  else
  { fill  = (long *)malloc(fillsize * 4 + 256);  /* +256 is insurance */
      if ( fill == NULL )
        exagoge(-1,"Insufficient memory","");
    fill = fill + 8 - ((long)fill & 0x1f)/4 ; /*align 32bytes*/
  }


  for (i=0; i<fillsize + 4; i++)
    *(fill + i) = 0xffffffff;



#ifdef DEBUG
  printf("p_org = %lx  elsize =%lx \n",(long)p_org,elsize);
#endif




/*  Get physical address of memory  */

  if (init_pagdir()) exagoge(-1,"Data Segment Selector Points LDT","");

#ifdef PRINT_IMED
  if( v==1 )
  { fprintf(stdout,"Cache fill %08lX - %08lX\n",get_phyadr(p_org),get_phyadr(p_org+elsize));
    fprintf(stdout,"Dummy fill %08lX - %08lX\n",get_phyadr(fill),get_phyadr(fill+fillsize));
  }
#endif

  DiscontinuousCounter = 0;
  if (elsize > 1024)
  { j = get_phyadr(p_org);
    for(i=1024; i<elsize; i+=1024)
    { k = get_phyadr(p_org + i);
      if ( j + 4096 != k)
      { 
#ifdef DEBUG
fprintf(stderr,"j:%ld ,k:%ld\n",j,k);
#endif
        DiscontinuousCounter++;
      }
      j = k;
    }
  }
  if( DiscontinuousCounter > 1)
    fprintf(stdout,"Warning(pfm686) : Physical memory was allocated discontinuously(%ld).\n",DiscontinuousCounter);



/*  cpuid  */
#ifdef PRINT_IMED
  if ( get_cpuid(&vendor_string[0]) ) fprintf(stdout,"%s\n",vendor_string);
#endif

#ifdef DEBUG
  printf("/* cli */\n");
#endif

  cli;






/* evaluate clock frequency */

  GetCycleTime();

  freq = .000001/CycleTime;

#ifdef PRINT_IMED
  fprintf(stdout,"CPU Frequency %6.2f[MHz]\n",freq);
#endif






/* e-cache read */
  readblock_er = fill_test_code(p_org,elsize);
  for (i=0; i<4; i++)
  { TickSet;
      call_test_code(p_org);
    TickGet;
  }
  counter_val_er = ExactTick();

#ifdef DEBUG
fprintf(stdout,"CounterValER:%ld  \n",counter_val_er);
#endif

/* call overhead of E-cache read */
  
  *p_org = 0xc3; /* ret immediate */
  for(i=0; i<4; i++)
  {
    TickSet;
      call_test_code(p_org);
    TickGet;
  }
  counter_val_er -= ExactTick();

  time_er = (double)(counter_val_er * CycleTime * 1e+9 )/(double)(readblock_er * 24 / 4 );
#ifdef PRINT_IMED
  fprintf(stdout,"CounterValER:%ld  CycleTime:%e\n",counter_val_er,CycleTime);
  fprintf(stdout,"E-cache read  %6.2f[ns/dword] :%5.2f[clocks]\n",time_er,time_er/(1000./freq));
#endif




/* E-cache write */
    set_code_continuous_push(p_org);
    for(j=0; j<4; j++)
    {
      load_string(p_org,elsize+PUSH_CODE );
      TickSet;
        do_continuous_push(p_org, no_of_push, stack_start_point);
      TickGet;
    }
    counter_val_ew = ExactTick();

/* for & call overhead of E-cache write */

  set_code_continuous_push_overhead(p_org);
  for(j=0; j<4; j++)
  {
    load_string(p_org,elsize+PUSH_CODE );
    TickSet;
      do_continuous_push(p_org, no_of_push, stack_start_point);
    TickGet;
  }
  counter_val_ew -= ExactTick();

  time_ew = ((double)counter_val_ew * CycleTime * 1e+9  - no_of_push*loop_overhead)/(double)elsize;
#ifdef PRINT_IMED
  fprintf(stdout,"CounterValEW:%ld  CycleTime:%e\n",counter_val_ew,CycleTime);
  fprintf(stdout,"E-cache write %6.2f[ns/dword] :%5.2f[clocks]\n",time_ew,time_ew/(1000./freq));
#endif






/* main read */

#ifdef DEBUG
  fprintf(stdout,"fill:%lx  fillsize:%lx  p_org:%lx  allocsize:%lx \n", fill,fillsize,p_org,allocsize);
#endif
  readblock_mr = fill_test_code(p_org,allocsize);
  fill_test_code(fill,fillsize);
#ifdef DEBUG
  fprintf(stdout,"success!  fill_test_code(fill,fillsize);  \n");
#endif
  for (i=0; i<4; i++)
  {
    call_test_code(fill);

    TickSet;
    call_test_code(p_org);
    TickGet;
  }
  counter_val_mr = ExactTick() - io_delay;
  time_mr = (double)(counter_val_mr * CycleTime * 1e+9 )/(double)(readblock_mr * 24 / 4 );

#ifdef PRINT_IMED
  fprintf(stdout,"main    read  %6.2f[ns/dword] :%5.2f[clocks]\n",time_mr,time_mr/(1000./freq));
#endif




/* main write */

  fill_test_code(fill,fillsize);
  set_code_continuous_push(p_org);
  for (i=0; i<4; i++)
  {
    call_test_code(fill);
    TickSet;
    do_continuous_push(p_org, no_of_push_allocsize, stack_start_point_allocsize);
    TickGet;
  }
  counter_val_mw = ExactTick() - io_delay;
  time_mw = ((double)counter_val_mw * CycleTime * 1e+9  - no_of_push_allocsize*loop_overhead)/(double)allocsize  ;
#ifdef PRINT_IMED
  fprintf(stdout,"main   write  %6.2f[ns/dword] :%5.2f[clocks]\n",time_mw,time_mw/(1000./freq));
#endif




/* Recover timer IC  */
  IOtickRecover;
  sti;

  free(p_org);
  free(fill);



/*  print   */


#ifndef PRINT_IMED
  if ( get_cpuid(&vendor_string[0]) )
  { fprintf(stdout,"------------------------------------------\n");
    fprintf(stdout,"%s\n",vendor_string);
  }


  if( v==1 )
  { fprintf(stdout,"| Cache fill %08lX - %08lX         |\n",get_phyadr(p_org),get_phyadr(p_org+elsize));
    fprintf(stdout,"| Dummy fill %08lX - %08lX         |\n",get_phyadr(fill),get_phyadr(fill+fillsize));
  }
  if( CacheSizeString[0] != '\0' )
    fprintf(stdout,"%s\n",CacheSizeString);
  fprintf(stdout,"|----------------------------------------|\n");
  { char st[5][10];
    sprintf(st[0],"%6.2f",freq);
    sprintf(st[1],"%7.3f",time_er);
    sprintf(st[2],"%7.3f",time_ew);
    sprintf(st[3],"%7.3f",time_mr);
    sprintf(st[4],"%7.3f",time_mw);
    
    if ( fabs( devide - 1.0) < 0.001 ) 
      fprintf(stdout,"|  %6s[MHz]  | [ns/dword] |[CPUclocks]|\n",st[0]);
    else
      fprintf(stdout,"|%6s/%3.1f[MHz]| [ns/dword] |[EXTclocks]|\n",st[0],devide);
    fprintf(stdout,"|---------------+------------+-----------|\n");
    fprintf(stdout,"| E-cache read  | %8s   |  %6.3f   |\n",st[1],time_er/(1000./freq)/devide);
    fprintf(stdout,"| E-cache write | %8s   |  %6.3f   |\n",st[2],time_ew/(1000./freq)/devide);
    fprintf(stdout,"| main    read  | %8s   |  %6.3f   |\n",st[3],time_mr/(1000./freq)/devide);
    fprintf(stdout,"| main    write | %8s   |  %6.3f   |\n",st[4],time_mw/(1000./freq)/devide);
    fprintf(stdout,"------------------------------------------\n");
/*
    printf("[%s]",st[0]);
    printf("[%s]",st[1]);
    printf("[%s]",st[2]);
    printf("[%s]",st[3]);
    printf("[%s]",st[4]);
*/
  }
  
#endif
}



